Attribute VB_Name = "DefineModule"
Option Explicit

Public Const OPTION_FILE = "vb6imap4.ini"

Public Id As String
Public Pass As String
Public Imap4Name As String
Public Imap4Port As Integer
Public Imap4Ssl As Integer
Public Imap4Auth As Integer
Public SmtpName As String
Public SmtpPort As Integer
Public SmtpSsl As Integer
Public SmtpAuth As Integer
Public MailAddress As String
Public MailBox As String
Public TrashMailBox As String
Public SentMailBox As String
Public NameString As String
Public Socket As Integer
Public TimerCount As Integer
Public SendResult As Integer
Public SendTo As String
Public SendSubject As String
Public SendBody As String
Public SendAttach As String
Public DeleteFlag As Boolean
Public FirstFlag As Boolean

Public Const HEADER_MAX = 8192
Public Const BODY_MAX = 32796
Public Const PATH_MAX = 256

Public Const SM_CXVSCROLL = 2
Public Const SM_CYCAPTION = 4
Public Const SM_CYMENU = 15
Public Const SM_CXFRAME = 32
Public Const SM_CYFRAME = 33
Public Const LVS_EX_FULLROWSELECT = &H20
Public Const LVM_FIRST = &H1000
Public Const LVM_GETCOLUMNWIDTH = LVM_FIRST + 29
Public Const LVM_SETCOLUMNWIDTH = LVM_FIRST + 30
Public Const LVM_GETEXTENDEDLISTVIEWSTYLE = LVM_FIRST + &H37
Public Const LVM_SETEXTENDEDLISTVIEWSTYLE = LVM_FIRST + &H36
Public Const SHGFI_ICON = &H100
Public Const SHGFI_SMALLICON = &H1
Public Const SHGFI_USEFILEATTRIBUTES = &H10
Public Const MAX_PATH = 260
Public Const SW_SHOW = 5
Public Const GWL_WNDPROC = -4
Public Const WM_RECEIVE_MAIL As Long = &H8001&

Public Type SHFILEINFO
   hIcon          As Long
   iIcon          As Long
   dwAttributes   As Long
   szDisplayName  As String * MAX_PATH
   szTypeName     As String * 80
End Type

Private OldWndProc As Long

Public Declare Function SendMessage Lib "user32" Alias "SendMessageA" (ByVal hwnd As Long, ByVal wMsg As Long, ByVal wParam As Long, lParam As Any) As Long
Public Declare Function DrawIconEx Lib "user32" (ByVal hdc As Long, ByVal xLeft As Long, ByVal yTop As Long, ByVal hIcon As Long, ByVal cxWidth As Long, ByVal cyWidth As Long, ByVal istepIfAniCur As Long, ByVal hbrFlickerFreeDraw As Long, ByVal diFlags As Long) As Long
Public Declare Function SHGetFileInfo Lib "shell32.dll" Alias "SHGetFileInfoA" (ByVal pszPath As String, ByVal dwFileAttributes As Long, psfi As SHFILEINFO, ByVal cbSizeFileInfo As Long, ByVal uFlags As Long) As Long
Public Declare Function DestroyIcon Lib "user32" (ByVal hIcon As Long) As Long
Public Declare Function GetTempPath Lib "kernel32" Alias "GetTempPathA" (ByVal nBufferLength As Long, ByVal lpBuffer As String) As Long
Public Declare Function ShellExecute Lib "shell32.dll" Alias "ShellExecuteA" (ByVal hwnd As Long, ByVal lpOperation As String, ByVal lpFile As String, ByVal lpParameters As String, ByVal lpDirectory As String, ByVal nShowCmd As Long) As Long
Public Declare Function GetSystemMetrics Lib "user32" (ByVal nIndex As Long) As Long
Public Declare Function GetPrivateProfileString Lib "kernel32" Alias "GetPrivateProfileStringA" (ByVal lpApplicationName As String, ByVal lpKeyName As Any, ByVal lpDefault As String, ByVal lpReturnedString As String, ByVal nSize As Long, ByVal lpFileName As String) As Long
Public Declare Function GetPrivateProfileInt Lib "kernel32" Alias "GetPrivateProfileIntA" (ByVal lpApplicationName As String, ByVal lpKeyName As String, ByVal nDefault As Long, ByVal lpFileName As String) As Long
Public Declare Function WritePrivateProfileString Lib "kernel32" Alias "WritePrivateProfileStringA" (ByVal lpApplicationName As String, ByVal lpKeyName As Any, ByVal lpString As Any, ByVal lpFileName As String) As Long
Public Declare Function GetWindowLong Lib "user32.dll" Alias "GetWindowLongA" (ByVal hwnd As Long, ByVal nIndex As Long) As Long
Public Declare Function SetWindowLong Lib "user32.dll" Alias "SetWindowLongA" (ByVal hwnd As Long, ByVal nIndex As Long, ByVal dwNewLong As Long) As Long
Public Declare Function CallWindowProc Lib "user32.dll" Alias "CallWindowProcA" (ByVal lpPrevWndFunc As Long, ByVal hwnd As Long, ByVal msg As Long, ByVal wParam As Long, ByVal lParam As Long) As Long

Public Function WndProc(ByVal hwnd As Long, ByVal msg As Long, ByVal wParam As Long, ByVal lParam As Long) As Long
    WndProc = 0
    If msg = WM_RECEIVE_MAIL Then
        MainForm.GetMailList
    Else
        WndProc = CallWindowProc(OldWndProc, hwnd, msg, wParam, lParam)
    End If
End Function

Public Sub SetWndProc(ByVal hwnd As Long)
    OldWndProc = GetWindowLong(hwnd, GWL_WNDPROC)
    Call SetWindowLong(hwnd, GWL_WNDPROC, AddressOf WndProc)
End Sub

Public Sub ResetWndProc(ByVal hwnd As Long)
    Call SetWindowLong(hwnd, GWL_WNDPROC, OldWndProc)
End Sub

Public Function GetIniString(ByVal key As String, ByVal default As String) As String
    Dim s As String * 256
    GetPrivateProfileString "IMAP4", key, default, s, 256, App.Path + "\" + OPTION_FILE
    If InStr(s, Chr(0)) > 0 Then
        GetIniString = Left(s, InStr(s, Chr(0)) - 1)
    Else
        GetIniString = s
    End If
End Function

Public Function GetIniInt(ByVal key As String, ByVal default As Long) As Integer
    GetIniInt = GetPrivateProfileInt("IMAP4", key, default, App.Path + "\" + OPTION_FILE)
End Function

Public Sub SetIniString(ByVal key As String, ByVal s As String)
    WritePrivateProfileString "IMAP4", key, s, App.Path + "\" + OPTION_FILE
End Sub

Public Sub SetIniInt(ByVal key As String, ByVal data As Integer)
    Dim s As String
    s = str(data)
    WritePrivateProfileString "IMAP4", key, s, App.Path + "\" + OPTION_FILE
End Sub

